#ifndef Py_SAFECODE_H
#define Py_SAFECODE_H
#ifdef __cplusplus
extern "C" {
#endif

/***********************************************************

  safecode - which opcodes can definately never cause
  a recursive interpreter call

  Christian Tismer Y2K0304

******************************************************************/

#define	STOP_CODE_SAFE	1
#define	POP_TOP_SAFE	1
#define	ROT_TWO_SAFE	1
#define	ROT_THREE_SAFE	1
#define	DUP_TOP_SAFE	1
		
#define	UNARY_POSITIVE_SAFE	0
#define	UNARY_NEGATIVE_SAFE	0
#define	UNARY_NOT_SAFE		0
#define	UNARY_CONVERT_SAFE	0
		
#define	UNARY_INVERT_SAFE	0
		
#define	BINARY_POWER_SAFE	0
		
#define	BINARY_MULTIPLY_SAFE	0
#define	BINARY_DIVIDE_SAFE		0
#define	BINARY_MODULO_SAFE		0
#define	BINARY_ADD_SAFE	0
#define	BINARY_SUBTRACT_SAFE	0
#define	BINARY_SUBSCR_SAFE		0
		
#define	SLICE_SAFE			0
		
#define	STORE_SLICE_SAFE	0
		
#define	DELETE_SLICE_SAFE	0
		
#define	STORE_SUBSCR_SAFE	0
#define	DELETE_SUBSCR_SAFE	0
		
#define	BINARY_LSHIFT_SAFE	0
#define	BINARY_RSHIFT_SAFE	0
#define	BINARY_AND_SAFE		0
#define	BINARY_XOR_SAFE		0
#define	BINARY_OR_SAFE		0
		
		
#define	PRINT_EXPR_SAFE		0
#define	PRINT_ITEM_SAFE		0
#define	PRINT_NEWLINE_SAFE	0
		
#define	BREAK_LOOP_SAFE		1
		
#define	LOAD_LOCALS_SAFE	1
#define	RETURN_VALUE_SAFE	1
		
#define	EXEC_STMT_SAFE		0
		
#define	POP_BLOCK_SAFE		1
#define	END_FINALLY_SAFE	1
#define	BUILD_CLASS_SAFE	0
		
#define	STORE_NAME_SAFE		0
#define	DELETE_NAME_SAFE	0
#define	UNPACK_TUPLE_SAFE	0
#define	UNPACK_LIST_SAFE	0
#define	STORE_ATTR_SAFE		0
#define	DELETE_ATTR_SAFE	0
#define	STORE_GLOBAL_SAFE	0
#define	DELETE_GLOBAL_SAFE	0
		
#define	LOAD_CONST_SAFE		1
#define	LOAD_NAME_SAFE		1
#define	BUILD_TUPLE_SAFE	1
#define	BUILD_LIST_SAFE		1
#define	BUILD_MAP_SAFE		1
#define	LOAD_ATTR_SAFE		0
#define	COMPARE_OP_SAFE		0
#define	IMPORT_NAME_SAFE	0
#define	IMPORT_FROM_SAFE	0
		
#define	JUMP_FORWARD_SAFE	1
#define	JUMP_IF_FALSE_SAFE	0
#define	JUMP_IF_TRUE_SAFE	0
#define	JUMP_ABSOLUTE_SAFE	1
#define	FOR_LOOP_SAFE		0
		
#define	LOAD_GLOBAL_SAFE	1
		
#define	SETUP_LOOP_SAFE		1
#define	SETUP_EXCEPT_SAFE	1
#define	SETUP_FINALLY_SAFE	1
		
#define	LOAD_FAST_SAFE		1
#define	STORE_FAST_SAFE		0
#define	DELETE_FAST_SAFE	0
		
#define	SET_LINENO_SAFE		0
		
#define	RAISE_VARARGS_SAFE	0
#define	CALL_FUNCTION_SAFE	0
#define	MAKE_FUNCTION_SAFE	0
#define	BUILD_SLICE_SAFE	0

#ifdef __cplusplus
}
#endif
#endif /* !Py_SAFECODE_H */
